//(1)VALEDCu(zz https://github.com/adafruit/Adafruit_NeoPixel)
#include <Adafruit_NeoPixel.h>
//(2)Arduino HID Project 2.4.4(zz https://github.com/NicoHood/HID#arduino-hid-project-244)
#include <HID-Project.h>
#include <HID-Settings.h>

//L[R[hw
#define KC_NUML     0x53      // [NUM LOCK]

//KEY SCANp I/O`
#define   ROW_NUM 7
#define   COL_NUM 4
const int rowPins[ROW_NUM] = {  2,  3,  4,  5,  6,  7,  8 };  // OUTPUTw
const int colPins[COL_NUM] = {  9, 10, 16, 14 };        // INPUT_PULLUPw

//LEDp I/O`
#define NUMPIXELS     1     // VALED
#define NUM_LOCK_LED    21      // NumLock/샂[hLED|[gԍ

//VALED`
//  D2812   = NEO_RGB
//  WS2812B = NEO_GRB
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, NUM_LOCK_LED, NEO_GRB + NEO_KHZ800);  //NumLock LEDPin

//NumLockELED
int R[3];            // LEDF Red  (0-255)
int G[3];            // LEDF Green(0-255)
int B[3];            // LEDF Blue (0-255)

//KEYԐpz`
//KEYԂOƍŐVԂŔrāAωꍇɃL[R[h𑗐M
bool cur_key_sts[ROW_NUM][COL_NUM]; //ŐVKEY
bool old_key_sts[ROW_NUM][COL_NUM]; //OKEY

void setup()
{
  // put your setup code here, to run once:
  //L[XLsPin
  for (int i = 0; i < ROW_NUM; i++)
  {
    pinMode(rowPins[i], OUTPUT);
  }
  //L[XLPin
  for (int i = 0; i < COL_NUM; i++)
  {
    pinMode(colPins[i], INPUT_PULLUP);
  }
  //L[Ԃ
  for (int row = 0; row < ROW_NUM; row++)
  {
    //L[Ԃu[XvƂ
    for (int c = 0; c < COL_NUM; c++)
    {
      cur_key_sts[row][c] = HIGH;
      old_key_sts[row][c] = HIGH;
    }
    //L[XLsPinHIGH(inactive)ɂ
    digitalWrite(rowPins[row], HIGH);
  }
  //LED\(e샂[hʂRGBŐFw肷)
  //F1=
  R[0]=0;
  G[0]=10;
  B[0]=0;

  //VALEDCu
  pixels.begin();

  //HIDfoCX(zXgLEDԎ擾p)
  BootKeyboard.begin();
}

void loop()
{
  // put your main code here, to run repeatedly:
  static int mode = 0;//FύXp

  //L[ԕωȂƂitOj
  int chg = 0;

  // key matrix scan
  for (int row = 0; row < ROW_NUM; row++)
  {
    // swFL[XLJn(LOWo)
    digitalWrite(rowPins[row], LOW);

    for (int col = 0; col < COL_NUM; col++)
    {
      // wFL[ԓǂݏo(:LOWj
      cur_key_sts[row][col] = digitalRead(colPins[col]);

      // ȌԂƕωH
      if (cur_key_sts[row][col] != old_key_sts[row][col])
      {
        //uL[ԕωvƂ
        chg = 1;
      	
        // L[ĂH
        if (cur_key_sts[row][col] == LOW)
        {
            // L[R[hǉij
            BootKeyboard.add(KeyboardKeycode(KC_NUML));
        }
        else
        {
            // L[R[h폜ij
            BootKeyboard.remove(KeyboardKeycode(KC_NUML));
        }
        //݂̃L[ԂȌԂɃRs[
        old_key_sts[row][col] = cur_key_sts[row][col];
      }
	}
    // swFL[XLI(HIGHɖ߂)
    digitalWrite(rowPins[row], HIGH);
  }
  //L[ԕωH
  if ( chg == 1 )
  {
    //zXgɕωL[R[h𑗐M
    BootKeyboard.send();
  }

  //zXgLEDԂ擾
  int cur_led_sts = BootKeyboard.getLeds();
  
  //zXgNumLockԂON
  if( cur_led_sts & LED_NUM_LOCK )
  {
    //LED_(key_modeɏ]RGBw肷)
    pixels.setPixelColor(0, pixels.Color(R[mode],G[mode],B[mode]));
  }
  else
  {
    //LED()
    pixels.setPixelColor(0, pixels.Color(0,0,0));
  }
  //LEDo
  pixels.show();
}
